'use strict';var Vue=require('vue');function _interopDefaultLegacy(e){return e&&typeof e==='object'&&'default'in e?e:{'default':e}}var Vue__default=/*#__PURE__*/_interopDefaultLegacy(Vue);function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}var script = /*#__PURE__*/Vue__default['default'].extend({
  name: 'VueChillCodeInput',
  model: {
    prop: 'valueModel',
    event: 'update:valueModel'
  },
  props: {
    length: {
      type: Number,
      required: false,
      default: 4
    },
    valueModel: {
      type: String,
      required: false,
      default: ''
    },
    autoFocus: {
      type: Boolean,
      required: false,
      default: false
    },
    autoBlur: {
      type: Boolean,
      required: false,
      default: true
    },
    type: {
      type: String,
      required: false,
      default: 'text',
      validator: function validator(value) {
        return ['text', 'number', 'tel'].includes(value);
      }
    },
    password: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data: function data() {
    return {
      activeColumnIndex: null,
      content: '',
      dontEmit: false
    };
  },
  computed: {
    currentColumn: function currentColumn() {
      if (this.activeColumnIndex === null) {
        return null;
      }

      return this.$refs["field__".concat(this.activeColumnIndex)][0];
    },
    getType: function getType() {
      return this.password ? 'password' : this.type;
    }
  },
  methods: {
    blur: function blur() {
      var _this$currentColumn;

      (_this$currentColumn = this.currentColumn) === null || _this$currentColumn === void 0 ? void 0 : _this$currentColumn.blur();
    },
    focus: function focus() {
      this.setActiveIndex(0);
      this.currentColumn.focus();
    },
    clear: function clear() {
      for (var i = 0; i < this.length; i++) {
        this.getColumn(i).value = '';
      }

      this.computeContent();
    },
    setActiveIndex: function setActiveIndex(index) {
      this.activeColumnIndex = index;
    },
    getColumn: function getColumn(index) {
      var _this$$refs$;

      return ((_this$$refs$ = this.$refs["field__".concat(index)]) === null || _this$$refs$ === void 0 ? void 0 : _this$$refs$[0]) || null;
    },
    onBackspace: function onBackspace(event, index) {
      this.setActiveIndex(index);
      this.$refs["field__".concat(index)][0].value = '';
      event.preventDefault();

      if (index > 0) {
        var input = this.getColumn(index - 1);
        this.dontEmit = true;
        input === null || input === void 0 ? void 0 : input.focus();
        this.dontEmit = false;
      }
    },
    onDelete: function onDelete(index) {
      this.setActiveIndex(index);
    },
    onInput: function onInput(index) {
      this.dontEmit = true;
      this.setActiveIndex(index);
      var column = this.getColumn(index);
      var value = column.value;

      if (value.length > 1) {
        column.value = value[1];
      }

      this.computeContent();

      if (value.trim()) {
        var nextInput = this.getColumn(index + 1);

        if (nextInput) {
          nextInput.focus();
        } else {
          if (this.autoBlur) {
            this.$refs["field__".concat(index)][0].blur();
          }

          this.$emit('done', this.content);
        }
      }

      this.dontEmit = false;
    },
    onBlur: function onBlur() {
      if (this.dontEmit) {
        return;
      }

      this.setActiveIndex(null);
      this.$emit('blur');
    },
    computeContent: function computeContent() {
      this.content = Object.values(this.$refs).map(function (i) {
        return i[0].value;
      }).join('').trim();
      this.$emit('update:valueModel', this.content);
    },
    onPaste: function onPaste(event) {
      // @ts-ignore
      var content = (event.clipboardData || window.clipboardData).getData('text').trim();
      this.fillFields(content);
    },
    fillFields: function fillFields(content) {
      if (!(content !== null && content !== void 0 && content.length)) {
        return;
      }

      this.dontEmit = true;

      for (var i = 0; i < this.length; i++) {
        this.getColumn(i).value = content[i];
        this.computeContent();
        var nextIndex = i + 1;
        if (nextIndex) if (nextIndex === this.length) {
          if (this.autoBlur) {
            this.getColumn(i).blur();
            this.$emit('done', this.content);
          }

          break;
        } else {
          var _this$getColumn;

          (_this$getColumn = this.getColumn(nextIndex)) === null || _this$getColumn === void 0 ? void 0 : _this$getColumn.focus();
        }
      }

      this.dontEmit = false;
    }
  },
  mounted: function mounted() {
    this.fillFields(this.value);

    if (this.autoFocus) {
      this.focus();
    }
  }
});function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        return () => { };
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: () => context._renderStyles(context._styles)
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return (id, style) => addStyle(id, style, context);
}
function addStyle(id, css, context) {
    const group = css.media || 'default' ;
    const style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        let code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    let css = '';
    for (const key in styles) {
        const style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "holder"
  }, [_vm._ssrNode(_vm._ssrList(Array.from(Array(_vm.length).keys()), function (index) {
    return "<input" + _vm._ssrAttr("type", _vm.getType) + " data-v-4a8d234f>";
  }))]);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-4a8d234f_0", {
    source: ".holder[data-v-4a8d234f]{display:inline-flex;justify-content:center;padding:1em;background:#d3d3d3;border-radius:4px}input[data-v-4a8d234f]{font-size:20px;width:50px;height:50px;display:flex;justify-content:center;align-items:center;margin-right:10px;text-align:center;border-radius:6px;border:1px solid transparent;outline:transparent}input[data-v-4a8d234f]:active,input[data-v-4a8d234f]:focus{border:1px solid green}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__ = "data-v-4a8d234f";
/* module identifier */

var __vue_module_identifier__ = "data-v-4a8d234f";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, createInjectorSSR, undefined);// Import vue component

// Default export is installable instance of component.
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),
var component = /*#__PURE__*/(function () {
  // Assign InstallableComponent type
  var installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = function (Vue) {
    Vue.component('VueChillCodeInput', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default': component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;